import * as RbTree from './rb-tree';
import Cmp = RbTree.Cmp;
export { Cmp };
export declare type Bag<T> = {
    tree: RbTree.t<T, T>;
};
export declare type t<T> = Bag<T>;
export declare const of: <T>(cmp: RbTree.Cmp.t<T>) => Bag<T>;
export declare const add: <T>(bag: Bag<T>, key: NonNullable<T>, n?: number) => void;
export declare const get: <T>(bag: Bag<T>, key: T) => number;
/**
 * Removes `n` elements from multiset.
 * @returns Negative number if element has been deleted, positive if it hasn't been deleted, -0 if didn't exist.
 */
export declare const remove: <T>(bag: Bag<T>, key: T, n?: number) => -0 | number;
