/** Red. */
export declare const R = 1;
/** Black. */
export declare const B = 2;
/** Black-black. */
export declare const BB = 3;
/** Color. */
export declare type P = typeof R | typeof B | typeof BB;
/** Nil node. */
export declare const E: undefined;
/** Black-black nil node. */
export declare const EE: null;
/** Node. */
export declare type N<T> = typeof E | typeof EE | {
    c: P;
    l: N<T>;
    v: T;
    n: number;
    r: N<T>;
    s: number;
};
/** Non nil node. */
export declare type M<T> = NonNullable<N<T>>;
/** Node with explicit type for left and optionally right child. */
export declare type O<T, L, R = N<T>> = {
    c: P;
    l: L;
    v: T;
    n: number;
    r: R;
    s: number;
};
/** @returns node. */
export declare const mk: <T>(c: P, l: N<T>, v: T, n: number, r: N<T>) => {
    c: P;
    l: N<T>;
    v: T;
    n: number;
    r: N<T>;
    s: number;
};
