"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prelude_js_1 = require("./prelude.js");
const balance_js_1 = __importDefault(require("./balance.js"));
const rotate = (_) => {
    switch (true) {
        // rotate R (T BB a x b) y (T B c z d) = balance B (T R (T B a x b) y c) z d
        case _.c === prelude_js_1.R && _.l?.c === prelude_js_1.BB && _.r?.c === prelude_js_1.B: {
            const { l: { l: a, v: x, n: i, r: b }, v: y, n: j, r: { l: c, v: z, n: k, r: d } } = _;
            return (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.B, (0, prelude_js_1.mk)(prelude_js_1.R, (0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, b), y, j, c), z, k, d));
        }
        // rotate R EE y (T B c z d) = balance B (T R E y c) z d
        case _.c === prelude_js_1.R && _.l === prelude_js_1.EE && _.r?.c === prelude_js_1.B: {
            const { v: y, n: j, r: { l: c, v: z, n: k, r: d } } = _;
            return (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.B, (0, prelude_js_1.mk)(prelude_js_1.R, prelude_js_1.E, y, j, c), z, k, d));
        }
        // rotate R (T B a x b) y (T BB c z d) = balance B a x (T R b y (T B c z d))
        case _.c === prelude_js_1.R && _.l?.c === prelude_js_1.B && _.r?.c === prelude_js_1.BB: {
            const { l: { l: a, v: x, n: i, r: b }, v: y, n: j, r: { l: c, v: z, n: k, r: d } } = _;
            return (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, (0, prelude_js_1.mk)(prelude_js_1.R, b, y, j, (0, prelude_js_1.mk)(prelude_js_1.B, c, z, k, d))));
        }
        // rotate R (T B a x b) y EE = balance B a x (T R b y E)
        case _.c === prelude_js_1.R && _.l?.c === prelude_js_1.B && _.r === prelude_js_1.EE: {
            const { l: { l: a, v: x, n: i, r: b }, v: y, n: j } = _;
            return (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, (0, prelude_js_1.mk)(prelude_js_1.R, b, y, j, prelude_js_1.E)));
        }
        // rotate B (T BB a x b) y (T B c z d) = balance BB (T R (T B a x b) y c) z d
        case _.c === prelude_js_1.B && _.l?.c === prelude_js_1.BB && _.r?.c === prelude_js_1.B: {
            const { l: { l: a, v: x, n: i, r: b }, v: y, n: j, r: { l: c, v: z, n: k, r: d } } = _;
            return (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.BB, (0, prelude_js_1.mk)(prelude_js_1.R, (0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, b), y, j, c), z, k, d));
        }
        // rotate B EE y (T B c z d) = balance BB (T R E y c) z d
        case _.c === prelude_js_1.B && _.l === prelude_js_1.EE && _.r?.c === prelude_js_1.B: {
            const { v: y, n: j, r: { l: c, v: z, n: k, r: d } } = _;
            return (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.BB, (0, prelude_js_1.mk)(prelude_js_1.R, prelude_js_1.E, y, j, c), z, k, d));
        }
        // rotate B (T B a x b) y (T BB c z d) = balance BB a x (T R b y (T B c z d))
        case _.c === prelude_js_1.B && _.l?.c === prelude_js_1.B && _.r?.c === prelude_js_1.BB: {
            const { l: { l: a, v: x, n: i, r: b }, v: y, n: j, r: { l: c, v: z, n: k, r: d } } = _;
            return (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.BB, a, x, i, (0, prelude_js_1.mk)(prelude_js_1.R, b, y, j, (0, prelude_js_1.mk)(prelude_js_1.B, c, z, k, d))));
        }
        // rotate B (T B a x b) y EE = balance BB a x (T R b y E)
        case _.c === prelude_js_1.B && _.l?.c === prelude_js_1.B && _.r === prelude_js_1.EE: {
            const { l: { l: a, v: x, n: i, r: b }, v: y, n: j } = _;
            return (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.BB, a, x, i, (0, prelude_js_1.mk)(prelude_js_1.R, b, y, j, prelude_js_1.E)));
        }
        // rotate B (T BB a w b) x (T R (T B c y d) z e) = T B (balance B (T R (T B a w b) x c) y d) z e
        case _.c === prelude_js_1.B && _.l?.c === prelude_js_1.BB && _.r?.c === prelude_js_1.R && _.r.l?.c === prelude_js_1.B: {
            const { l: { l: a, v: w, n: h, r: b }, v: x, n: i, r: { l: { l: c, v: y, n: j, r: d }, v: z, n: k, r: e } } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.B, (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.B, (0, prelude_js_1.mk)(prelude_js_1.R, (0, prelude_js_1.mk)(prelude_js_1.B, a, w, h, b), x, i, c), y, j, d)), z, k, e);
        }
        // rotate B EE x (T R (T B c y d) z e) = T B (balance B (T R E x c) y d) z e
        case _.c === prelude_js_1.B && _.l === prelude_js_1.EE && _.r?.c === prelude_js_1.R && _.r.l?.c === prelude_js_1.B: {
            const { v: x, n: i, r: { l: { l: c, v: y, n: j, r: d }, v: z, n: k, r: e } } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.B, (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.B, (0, prelude_js_1.mk)(prelude_js_1.R, prelude_js_1.E, x, i, c), y, j, d)), z, k, e);
        }
        // rotate B (T R a w (T B b x c)) y (T BB d z e) = T B a w (balance B b x (T R c y (T B d z e)))
        case _.c === prelude_js_1.B && _.l?.c === prelude_js_1.R && _.l.r?.c === prelude_js_1.B && _.r?.c === prelude_js_1.BB: {
            const { l: { l: a, v: w, n: h, r: { l: b, v: x, n: i, r: c } }, v: y, n: j, r: { l: d, v: z, n: k, r: e } } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.B, a, w, h, (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.B, b, x, i, (0, prelude_js_1.mk)(prelude_js_1.R, c, y, j, (0, prelude_js_1.mk)(prelude_js_1.B, d, z, k, e)))));
        }
        // rotate B (T R a w (T B b x c)) y EE = T B a w (balance B b x (T R c y E))
        case _.c === prelude_js_1.B && _.l?.c === prelude_js_1.R && _.l.r?.c === prelude_js_1.B && _.r === prelude_js_1.EE: {
            const { l: { l: a, v: w, n: h, r: { l: b, v: x, n: i, r: c } }, v: y, n: j } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.B, a, w, h, (0, balance_js_1.default)((0, prelude_js_1.mk)(prelude_js_1.B, b, x, i, (0, prelude_js_1.mk)(prelude_js_1.R, c, y, j, prelude_js_1.E))));
        }
        // rotate color a x b = T color a x b
        default:
            return _;
    }
};
exports.default = rotate;
//# sourceMappingURL=rotate.js.map